import numpy as np
import matplotlib.pyplot as plt
from matplotlib.colors import ListedColormap
import matplotlib as mpl
from matplotlib.patches import Patch

def support_generate(N):
    if N == 1:
        return np.array([[1, 0, 1, 0], [0, 1, 0, 1]]), np.array([[0, 1, 1, 0], [1, 0, 0, 1]])
    
    support1, support2 = support_generate(N-1)

    size1 = 2 ** N
    size2 = 3 * size1 - 2

    result1 = np.zeros((size1, size2))
    result2 = np.zeros((size1, size2))

    result1[:size1//2, 0] = 1
    result1[-size1//2:, 1] = 1
    result1[:size1//2, 2:2+support1.shape[1]] = support1
    result1[-size1//2:, -support1.shape[1]:] = support1

    result2[:size1//2, 1] = 1
    result2[-size1//2:, 0] = 1
    result2[:size1//2, 2:2+support1.shape[1]] = support2
    result2[-size1//2:, -support1.shape[1]:] = support2

    return result1, result2

N = 3
a, b = support_generate(N)
size1 = 2 ** N
size2 = 3 * size1 - 2
linewidth = 16.0 / size1
fig, (ax1, ax2) = plt.subplots(1, 2, figsize = (10,5))
cmap = ListedColormap(['w', 'gold'])
ax1.matshow(a, cmap = cmap)
ax1.set_xticklabels([])
ax1.set_yticklabels([])
#ax1.set_title(r'$\mathbf{X}$')
ax1.tick_params(axis='both', which='both', length=0)
ax1.set_xticks(np.arange(-.5, size2, 1))
ax1.set_yticks(np.arange(-.5, size1, 1))
ax1.grid(color='black', linestyle='-', linewidth=linewidth)

ax2.matshow(b.T, cmap = cmap)
ax2.set_xticklabels([])
ax2.set_yticklabels([])
#ax2.set_title(r'$\mathbf{Y}^\top$')
ax2.tick_params(axis='both', which='both', length=0)
ax2.set_xticks(np.arange(-.5, size1, 1))
ax2.set_yticks(np.arange(-.5, size2, 1))
ax2.grid(color='black', linestyle='-', linewidth=linewidth)

plt.grid(which='minor')
plt.show()
print(a)
print(b)